
Module AP
contains
 function matmulx(A,B,R1,C1,R2,C2) result(out)
 integer R1,C1,R2,C2

real(8) A(R1,C1),B(R2,C2),out(R1,C2)
 real(8) alpha,beta
 
 alpha = 1.0d0
      beta = 0.0d0


!call dgemm
call dgemm('N','N',R1,C2,C1,alpha,A,R1,B,C1,beta,out,R1)

endfunction

 

endmodule














subroutine kalmanfilter(MU,F,SVOL,iAMAT,Q,T,NN,NN1,N,y,x,beta0,p00,BETA,p11)

!DEC$ attributes dllexport, alias: 'kalmanfilter' :: kalmanfilter
!NN=Number of states
!NN1=N*L+ex cols(x)
!nn2=n*(n-1)/2
use AP
implicit none
Real(8) NN,NN1,N,T,TNN
Real(8) MU(1,int(NN)),F(int(NN),int(NN)),R(int(N),int(N)),Q(int(NN),int(NN)),y(int(T),int(N)),x(int(T),int(NN1)),beta0(1,int(NN)),p00(int(NN),int(NN)),BETA(int(T),int(NN)),PROBLEM
Real(8) beta10(1,int(NN)),beta11(1,int(NN)),p10(int(NN),int(NN)),p11(int(NN),int(NN)),yhat(1,int(N)),eta(1,int(N)),feta(int(N),int(N))
real(8) K(int(NN),int(N)),ifeta(int(N),int(N)),ytemp(1,int(N))
real(8) H(int(N),int(NN)),iAMAT(int(N),int(N))
Real(8) beta2(int(T),int(NN))
Real(8) rcondx,small,SVOL(int(T),int(N)),beta11T(int(NN),1)
Real(8) AA(int(N),int(N)),HH(int(N),int(N)),AAINV(int(N),int(N))

integer i,j,info,seed(4),n2,n3,ii,jj
n2=int(N)
n3=int(NN1)

!kalman filter

beta11=beta0
p11=p00


do i=1,int(T)
ytemp(1,1:int(N))=y(i,1:int(N))
H=0.00000000000
jj=1
do j=1,N2
H(j,jj:jj+n3-1)=x(i,1:n3)
jj=jj+N3
enddo

HH=0.000000000000
do j=1,N2
HH(j,j)=(svol(i,j))
enddo

R=matmulx(iamat,matmulx(HH,transpose(iamat),n2,n2,n2,n2),n2,n2,n2,n2)


!Prediction
beta10=beta11 !MU+matmulx(beta11,transpose(F),1,int(NN),int(NN),int(NN))  !checked
p10= p11!matmulx(F,matmulx(p11,transpose(F),int(NN),int(NN),int(NN),int(NN)),int(NN),int(NN),int(NN),int(NN))+Q  !checked F*p00*F'+Q;
yhat=transpose(matmulx(H,transpose(beta10),int(N),int(NN),int(NN),1)) !checked                                         
eta=ytemp-yhat   !checked           
feta=matmulx(H,matmulx(p10,transpose(H),int(NN),int(NN),int(NN),int(N)),int(N),int(NN),int(NN),int(N))+R  !feta=(xx*p10*xx')+r; !checked

!updating
call invertsym(feta,n2,ifeta)

K= matmulx(matmulx(p10,transpose(H),int(NN),int(NN),int(NN),int(N)),ifeta,int(NN),int(N),int(N),int(N))  !(P10*xx')*invpd(feta); checked  
beta11T=transpose(beta10)+matmulx(K,transpose(eta),int(NN),int(N),int(N),1)                              
beta11=transpose(beta11T)   !beta11=(beta10'+k*eta')'; checked                  
p11=p10-matmulx(K,matmulx(H,p10,int(N),int(NN),int(NN),int(NN)),int(NN),int(N),int(N),int(NN))     !p11=p10-k*(xx*p10); checked
BETA(i,1:int(NN))=beta11(1,1:int(NN))   

enddo


end subroutine kalmanfilter



subroutine invertsym(A,N,OUT)
implicit none
integer,intent(in)::N
real(8),intent(in)::A(N,N)
real(8),intent(out)::OUT(N,N)
integer info,i,j
external DPOTRF,DPOTRI

OUT=A
!chol factorisation
call DPOTRF('U',N,OUT,N,info)
!Inverse
call DPOTRI('U',N,OUT,N,info)
do i=1,n
do j=i+1,n
out(j,i)=out(i,j)
end do
end do

end subroutine invertsym


subroutine invert(A,N,OUT)
implicit none

integer,intent(in)::N
real(8),intent(in)::A(N,N)
real(8),intent(out)::OUT(N,N)
DOUBLE PRECISION WORK(N)
integer IPIV(N),INFO,LWORK
external DGETRI,DGETRF
LWORK=N
OUT=A
!lU factorisation
call DGETRF( N, N, OUT, N, IPIV, INFO )

!Inverse
call DGETRI( N, OUT, N, IPIV, WORK, LWORK, INFO )

end subroutine invert

